/*
 *  mem.h
 *  -----
 *
 *  memcmp() for the alteon firmware.  
 *
 *  TJD July '99
 *
 *  $Id: mem.h,v 1.1 1999/08/10 15:05:33 tjd21 Exp $
 */

/*
 *  Slow - needs some attention for optimisation.
 */ 

static __inline__ int
memcmp(const char *s1, const char *s2, U32 n)
{
    register char one, two;
    register U32  c = n;
    
    while (c > 0)
    {
	one = *s1;
	two = *s2;
	if (one != two)
	    return (one - two);
	s1 ++;
	s2 ++;
	c --;
    }
    return 0;
}

/*
 *  How to load a 16-bit-aligned 32-bit-value
 */

#define UNALIGNED_LOAD_32(_x) (((U16*)(_x))[0] << 16 | ((U16*)(_x))[1])

/*
 *  EOF (mem.h)
 */
